package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.inventory.MenuType
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPowered
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import net.minecraft.world.SimpleContainer

abstract class PoweredMatteryMenu protected constructor(
	menuType: MenuType<*>,
	containerID: Int,
	inventory: Inventory,
	tile: BlockEntityMatteryPowered? = null
) : MatteryMenu(menuType, containerID, inventory, tile) {
	@JvmField
	val powerWidget: LevelGaugeWidget

	@JvmField
	var batterySlot: BatterySlot? = null

	init {
		if (tile == null || tile.getCapability(MatteryCapability.ENERGY).resolve().isEmpty) {
			powerWidget = LevelGaugeWidget(this)
		} else {
			powerWidget = LevelGaugeWidget(this, tile.getCapability(MatteryCapability.ENERGY).resolve().get())
		}
	}

	@JvmOverloads
	protected fun addBatterySlot(x: Int = 10, y: Int = 66) {
		val container = if (tile is BlockEntityMatteryPowered) tile.battery_container else SimpleContainer(1)
		val batterySlot = BatterySlot(container, 0, x, y)
		addSlot(batterySlot)
		this.batterySlot = batterySlot
	}
}
